<template>
    <view class="user-set">
        <navigator :url="`/pages/user_data/user_data`">
            <view class="item flex bg-white mt-[20rpx]">
                <u-avatar :src="userInfo.avatar" shape="square" :size="100"></u-avatar>
                <view class="ml-[20rpx] flex flex-1 justify-between items-center">
                    <view>
                        <view class="mb-[15rpx] text-xl font-medium">{{ userInfo.nickname }}</view>
                        <view class="text-content text-xs">账号：{{ userInfo.username }}</view>
                    </view>
                    <u-icon name="arrow-right" color="#666"></u-icon>
                </view>
            </view>
        </navigator>
        <view
            class="item bg-white mt-[20rpx] btn-border flex flex-1 justify-between"
            @click="handlePwd"
        >
            <view class="">登录密码</view>
            <u-icon name="arrow-right" color="#666"></u-icon>
        </view>
        <!-- #ifdef MP-WEIXIN || H5 -->
        <view
            class="item bg-white flex flex-1 justify-between"
            @click="handleBindwx"
            v-if="isWeixin"
        >
            <view class="">绑定微信</view>
            <view class="flex justify-between">
                <view class="text-muted mr-[20rpx]">
                    {{ userInfo.isBindMnp ? '已绑定' : '未绑定' }}
                </view>
                <!-- <u-icon name="arrow-right" color="#666"></u-icon> -->
            </view>
        </view>
        <!-- #endif -->
        <navigator :url="`/pages/agreement/agreement?type=${AgreementEnum.PRIVACY}`">
            <view class="item bg-white mt-[20rpx] btn-border flex flex-1 justify-between">
                <view class="">隐私政策</view>
                <u-icon name="arrow-right" color="#666"></u-icon>
            </view>
        </navigator>
        <navigator :url="`/pages/agreement/agreement?type=${AgreementEnum.SERVICE}`">
            <view class="item bg-white btn-border flex flex-1 justify-between">
                <view class="">服务协议</view>
                <u-icon name="arrow-right" color="#666"></u-icon>
            </view>
        </navigator>
        <navigator url="/pages/as_us/as_us">
            <view class="item bg-white flex flex-1 justify-between">
                <view class="">关于我们</view>
                <view class="flex justify-between">
                    <view class="text-muted mr-[20rpx]">
                        {{ appStore.config.version }}
                    </view>
                    <u-icon name="arrow-right" color="#666"></u-icon>
                </view>
            </view>
        </navigator>

        <view class="mt-[60rpx] mx-[26rpx]">
            <button class="bg-primary text-lg text-white rounded-full" @click="logoutHandle">
                退出登录
            </button>
        </view>

        <u-action-sheet
            :list="list"
            v-model="show"
            @click="handleClick"
            :safe-area-inset-bottom="true"
        ></u-action-sheet>
    </view>
</template>

<script setup lang="ts">
import { getUserInfo } from '@/api/user'
import { onLoad, onShow } from '@dcloudio/uni-app'
import { ref } from 'vue'
import { useAppStore } from '@/stores/app'
import { useUserStore } from '@/stores/user'
import { AgreementEnum } from '@/enums/agreementEnums'
import { isWeixinClient, getClient } from '@/utils/client'
import { ClientEnum } from '@/enums/appEnums'
import { apiBindwx } from '@/api/app'
// #ifdef H5
import wechatOa from '@/utils/wechat'
// #endif

const appStore = useAppStore()
const userStore = useUserStore()
const userInfo = ref<any>({
    avatar: '',
    nickname: '',
    username: ''
})
const list = ref([
    {
        text: '修改密码'
    },
    {
        text: '忘记密码'
    }
])
const isWeixin = ref(true)
// #ifdef H5
isWeixin.value = isWeixinClient()
// #endif

const show = ref(false)

// 获取用户信息
const getUser = async () => {
    const res = await getUserInfo()
    userInfo.value = res
}

// 绑定微信
const handleBindwx = async () => {
    uni.showLoading({
        title: '请稍后...'
    })
    if (userInfo.value.isBindMnp == true) {
        uni.$u.toast('该账号已经绑定微信！')
        return
    }
    try {
        let res: any = {}
        if (getClient() == ClientEnum.MP_WEIXIN) {
            res = await uni.login({
                provider: 'weixin'
            })
            await apiBindwx({
                code: res.code
            })
            await getUser()
            await userStore.getUser()
            uni.hideLoading()
            await uni.$u.toast('绑定成功！')
        } else if (getClient() == ClientEnum.OA_WEIXIN) {
            wechatOa.getUrl()
        }
    } catch (error: any) {
        uni.hideLoading()
        uni.$u.toast(error)
    }
}

// 修改/忘记密码
const handleClick = (index: number) => {
    switch (index) {
        case 0:
            uni.navigateTo({ url: '/pages/change_password/change_password' })
            break
        case 1:
            uni.navigateTo({ url: '/pages/forget_pwd/forget_pwd' })
            break
    }
}

const handlePwd = () => {
    if (!userInfo.value.isPassword)
        return uni.navigateTo({ url: '/pages/change_password/change_password?type=set' })
    show.value = true
}

// 退出登录
const logoutHandle = () => {
    uni.showModal({
        content: '是否退出登录？',
        confirmColor: '#4173FF',
        success: ({ cancel }) => {
            if (cancel) return
            userStore.logout()
            uni.redirectTo({ url: '/pages/login/login' })
        }
    })
}

onShow(() => {
    getUser()
})

onLoad(async (options) => {
    const { code } = options
    if (code) {
        await apiBindwx({
            code: code,
            terminal: getClient()
        })
        await uni.$u.toast('绑定成功！')
        await uni.redirectTo({ url: '/pages/index/index' })
    }
})
</script>

<style lang="scss" scoped>
.user-set {
    .item {
        padding: 30rpx;
    }

    .btn-border {
        border-bottom: 2rpx solid #f8f8f8;
    }
}
</style>
